from django.shortcuts import render, redirect
from django.http import HttpResponse
from kisan.models import ProductData, SubCategory, Category, Rating
from accounts.models import SellerData, KisanData
from accounts.views import kisan_login_required,cust_login_required
from cart.models import PCart, Quantity, ContactCart, ContactList, CPCart
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger
from django.contrib import messages
from django.contrib.auth.models import User
from django.contrib.auth.decorators import login_required
import random
from django.db.models import Q

# Create your views here.
def home(request):
    return render(request, 'homepage.html')


def robotfile(request):
    lines = [
        "User-agent: *",
        "Disallow: /cgi-bin/",
        "Disallow: /admin/",
        "Disallow: /backup/",
        "Disallow: /modules/",
        "Disallow: /config/",
        "Disallow: /wp-admin/",
        "Sitemap: https://mandigram.com/sitemap.xml",
    ]
    return HttpResponse("\n".join(lines), content_type="text/plain")
    
    
def get_subcategory(request):
    id = request.GET.get('id', '')
    result = list(SubCategory.objects.filter(category_id=int(id)).values('id', 'cat_title'))
    return HttpResponse(json.dumps(result), content_type="application/json")


def cat_view(request, cat_name, cat_id):
    sub_result = list(SubCategory.objects.filter(category=cat_id))
    cat_det = Category.objects.get(id=cat_id)
    page = request.GET.get('page', 1)
    paginator = Paginator(sub_result, 15)
    try:
        subcat_list = paginator.page(page)
    except PageNotAnInteger:
        subcat_list = paginator.page(1)
    except EmptyPage:
        subcat_list = paginator.page(paginator.num_pages)
    return render(request, 'home/cat_view.html', {'subcategory': subcat_list, 'cat_nm': cat_name, 'cat_det': cat_det})


def subcat_view(request, cat_name, subcat_name, subcat_id):
    sabcat_det = SubCategory.objects.get(id=subcat_id)
    prod_results = list(ProductData.objects.filter(subcategory_id=subcat_id))
    return render(request, 'home/subcat_view.html', {'product': prod_results, 'subcat_nm': subcat_name, 'sabcat_det': sabcat_det})

from accounts.models import UserData, SellerData, KisanData
from django.contrib.auth.models import User

def browse(request):
    # p = ProductData.objects.all()
    if request.user.is_authenticated :
        user = request.user.username
        if request.user.last_name == '1':
            query_Set = Category.objects.filter(Q(is_active=True) & Q(cat_type='KP'))
            # print("Customer")
        elif request.user.last_name == '2':
            query_Set = Category.objects.filter(Q(is_active=True) & Q(cat_type='SP'))
            # print('farmer')
        else:
            query_Set = Category.objects.filter(Q(is_active=True) & Q(cat_type='SP'))
            # print("seller")
    else:
        query_Set = Category.objects.filter(Q(is_active=True))
    page = request.GET.get('page', 1)
    paginator = Paginator(query_Set, 6)
    # page1 = request.GET.get(1, 1)
    # sub_cat = SubCategory.objects.all()
    # paginator1 = Paginator(sub_cat, 5)
    # sub_cat = paginator1.page(page1)

    try:
        cat = paginator.page(page)
    except PageNotAnInteger:
        cat = paginator.page(1)
    except EmptyPage:
        cat = paginator.page(paginator.num_pages)
    subcat1 = []
    try:
        for obj in cat:
            query_Set = SubCategory.objects.filter(Q(category=obj) & (Q(category__cat_type='KP') | Q(category__cat_type='SP')))
            page1 = request.GET.get(1, 1)
            paginator1 = Paginator(query_Set, 5)
            sub_cat = paginator1.page(page1)
            subcat1+=sub_cat
            random.shuffle(subcat1)
    except:
        pass
    return render(request, 'home/products_display.html', {'prods': 'p', 'categories': cat, 'sub_category': subcat1})


def subcategory_product(request, object_id):
    query_Set = ProductData.objects.filter(subcategory=object_id).order_by('p_price')
    subcat_des = SubCategory.objects.get(id=object_id)
    sub_cat = SubCategory.objects.all()
    cat = Category.objects.all()
    page = request.GET.get('page', 1)
    paginator = Paginator(query_Set, 5)
    try:
        prod = paginator.page(page)
    except PageNotAnInteger:
        prod = paginator.page(1)
    except EmptyPage:
        prod = paginator.page(paginator.num_pages)
    return render(request, 'home/subcat_products_display.html', {'prods': prod, 'categories': cat, 'sub_category': sub_cat, 'subcat_des': subcat_des})


# def desc(request, object_id):
#     product = ProductData.objects.get(id=object_id)
#     sellers = SellerData.objects.all()
#     list_products = ProductData.objects.filter(p_name__icontains=product.p_name).order_by('p_price')
#     p1 = ProductData.objects.filter(id=list_products[0].id).values()
#     s = p1[0]['seller_name']
#     num_res1 = Rating.objects.filter(seller=s).count()
#     if num_res1 == 0:
#         co = 0
#         us = []
#     else:
#         co = Rating.objects.filter(seller=s).values()[0]['rate']
#         us1 = Rating.objects.get(seller=s)
#         us = us1.users.values_list()
#     if request.method == 'POST' and 'deleter' in request.POST:
#         Q = request.POST.get('quant', list_products[0].min_q)
#         num_res = PCart.objects.filter(user=request.user.email).count()
#         if num_res == 0:
#             p = PCart(user=request.user.email)
#             p.save()
#         q = Quantity(min_q=Q)
#         q.save()
#         p1 = PCart.objects.get(user__iexact=request.user.email)
#         p1.p_name.add(list_products[0])
#         p1.quant.add(q)
#         p1.save()
#     return render(request, 'home/product_description.html',
#                   {'data': product, 'listdata': list_products, 't': 0, 'co': co, 'us': us, 'seller': sellers})


def desc(request, object_id):
    product = ProductData.objects.get(id=object_id)
    sellers = SellerData.objects.all()
    list_products = ProductData.objects.filter(p_name__icontains=product.p_name).order_by('p_price')
    p1 = ProductData.objects.filter(id=list_products[0].id).values()
    s = p1[0]['seller_name']
    num_res1 = Rating.objects.filter(seller=s).count()
    if num_res1 == 0:
        co = 0
        us = []
    else:
        co = Rating.objects.filter(seller=s).values()[0]['rate']
        us1 = Rating.objects.get(seller=s)
        us = us1.users.values_list()
    if request.method == 'POST' or 'deleter' in request.POST and not request.user:
        Q = request.POST.get('quant', list_products[0].min_q)
        # user_ins = User.objects.get(username=request.user.username)
        user_ins = request.user
        num_res = CPCart.objects.filter(user=user_ins).count()
        if num_res == 0:
            p = CPCart(user=user_ins)
            p.save()
        q = Quantity(min_q=Q)
        q.save()
        # p1 = CPCart.objects.get(user__iexact=request.user.username)
        p1 = CPCart.objects.get(user__iexact=user_ins)
        p1.p_name.add(list_products[0])
        p1.quant.add(q)
        p1.save()
    else:
        if request.method == 'POST':
            messages.info(request, 'Please login to save product')
    return render(request, 'home/product_description.html',
                  {'data': product, 'listdata': list_products, 't': 0, 'co': co, 'us': us, 'seller': sellers})


def desc1(request, object_id):
    product = ProductData.objects.get(id=object_id)
    sellers = SellerData.objects.all()
    list_products = ProductData.objects.filter(p_name__icontains=product.p_name).order_by('p_price')[:5]
    p1 = ProductData.objects.filter(id=product.id).values()
    s = p1[0]['seller_name']
    num_res1 = Rating.objects.filter(seller=s).count()
    if num_res1 == 0:
        co = 0
    else:
        co = Rating.objects.filter(seller=s).values()[0]['rate']
    if (request.method == 'POST' or 'deleter' in request.POST) and request.user.is_authenticated:
        Q = request.POST.get('quant', product.min_q)
        # user_ins = User.objects.get(username=request.user.username)
        user_ins = request.user
        num_res = CPCart.objects.filter(user=user_ins).count()
        if num_res == 0:
            p = CPCart(user=user_ins)
            p.save()
        elif num_res > 1:
            print('object exist need to update')

        q = Quantity(min_q=Q)
        q.save()
        # p1 = CPCart.objects.get(user__iexact=request.user.username)
        p1 = CPCart.objects.get(user=user_ins)
        p1.p_name.add(list_products[0])
        p1.quant.add(q)
        p1.save()
    else:
        if request.method == 'POST':
            messages.info(request, 'Please login to save product')
    return render(request, 'home/product_description.html',
                  {'data': product, 'listdata': list_products, 't': 1, 'co': co, 'seller':sellers})


def desc2(request, string, seller_id, product_id):
    product = ProductData.objects.get(id=product_id)
    sellers = SellerData.objects.all()
    list_products = ProductData.objects.filter(p_name__icontains=product.p_name).order_by('p_price')[:5]
    p1 = ProductData.objects.filter(id=product.id).values()
    s = p1[0]['seller_name']
    num_res1 = Rating.objects.filter(seller=s).count()

    return render(request, 'home/product_description.html',
                  {'data': product, 'listdata': list_products, 't': 1,  'seller': sellers})

@login_required
def kisan_contact(request, object_id, object_name):
    # user_id = ProductData.objects.filter(id=object_id).values_list('s_username', flat=True) # hiding and updating below line for user
    user_id = ProductData.objects.filter(id=object_id).values_list('p_owner__username', flat=True)
    # seller = SellerData.objects.get(id=object_id, name=object_name)
    # contact_details = KisanData.objects.get(name=object_name)
    print(user_id[0])
    if KisanData.objects.filter(mobile=user_id[0]):
        contact_details = KisanData.objects.get(mobile=user_id[0])
    else:
        contact_details = SellerData.objects.get(email=user_id[0])
    print(contact_details)
    # print(contact_details.name)
    if request.method == 'POST' and 'deleter' in request.POST:
        id = str(request.POST.get('seller_id'))
        name = str(request.POST.get('seller_name'))
        phone = int(request.POST.get('seller_mobile'))
        # print(name, phone)
        p = ContactCart.objects.get_or_create(user=request.user.username)
        # print(request.user.email)
        p1 = ContactList.objects.filter(s_name=name, s_mobile=phone)
        print(p1.values())
        if p1==True:
            p2 = ContactList.objects.create(s_id=id, s_name=name, s_mobile=phone)
            print(p2)

            p[0].contact_list.add(p2)
            messages.info(request, 'Added in contact list')
            # return redirect('/')
        else:
            p2 = ContactList.objects.create(s_id=id, s_name=name, s_mobile=phone)
            print(p2)
            p[0].contact_list.add(p2)
            messages.info(request, 'Contact already exist')
            # return redirect('/')
    num_res1 = Rating.objects.filter(seller=object_name).count()
    if num_res1 == 0:
        co = 0
    else:
        co = Rating.objects.filter(seller=s).values()[0]['rate']
    return render(request, 'home/contact_detail.html',
                  {'contact_details': contact_details, 'co': co})

